From fcd21b0dfb4cf07f7c6fe81dd6e3d55abdd89467 Mon Sep 17 00:00:00 2001
From: manisha <manisha_kanyal.scsebtech@galgotiasuniversity.edu.in>
Date: Jun 09 2021 08:03:24 +0000
Subject: [PATCH 6/9] filter based implementation of wizard


---

diff --git a/src/App.js b/src/App.js
index ec0ae5d..8b8864d 100644
--- a/src/App.js
+++ b/src/App.js
@@ -6,7 +6,6 @@ import { BrowserRouter } from "react-router-dom"
 import Wizard from "./wizard/Wizard"
 import LandingPage from "./landingpage/LandingPage"
 import NotFound from "./NotFound"
-import Connecting from "./wizard/Connecting"
 
 class App extends Component {
   render() {
@@ -17,8 +16,6 @@ class App extends Component {
             <Route path="/" exact component={LandingPage} />
 
             <Route path="/wizard" component={Wizard} />
-            <Route path="/connecting" component={Connecting} />
-
             <Route path="/landingpage" component={LandingPage} />
             <Route component={NotFound} />
           </Switch>
diff --git a/src/wizard/FedoraEasyKarma.js b/src/wizard/FedoraEasyKarma.js
index 830cce5..41a05a1 100644
--- a/src/wizard/FedoraEasyKarma.js
+++ b/src/wizard/FedoraEasyKarma.js
@@ -1,5 +1,5 @@
 import React, { Component } from "react"
-import { CollapsableBadge, ModalBadge } from "./components"
+import { CollapsableBadge, CollapsableCard, ModalBadge } from "./components"
 
 export default class FedoraEasyKarmaItemsList extends Component {
   render() {
@@ -7,130 +7,131 @@ export default class FedoraEasyKarmaItemsList extends Component {
     else
       return (
         <div>
-          <h1>What is Karma</h1>
-          Before a new version of a package is pushed to the Fedora&apos;s Updates repository, it
-          needs to be tested and proved functional.{" "}
-          <CollapsableBadge expand_text="Tell me more about the process!">
-            The updates are kept in{" "}
-            <a target="_blank" rel="noopener noreferrer" href="https://bodhi.fedoraproject.org/">
-              Bodhi
-            </a>
-            , which acts as a gatekeeper between new package releases and the stable repositories.{" "}
-            Users (or automated systems) can then provide feedback in form of positive/negative
-            Karma, marking the update as working (or not) within the scope of their expectations.{" "}
-            An update can (and usually does) consist of several packages (rpms), that are going
-            through the acceptance process together.
-          </CollapsableBadge>
-          <h1 style={{ marginTop: 1 + "em" }}>Sure, let me do it!</h1>
-          <ol className="steps">
-            <li>
-              Fedora Accounts System (FAS) account is required.{" "}
-              <CollapsableBadge expand_text="Don&#39;t have one yet?">
-                <ul>
-                  <li>
-                    Visit{" "}
-                    <a
-                      target="_blank"
-                      rel="noopener noreferrer"
-                      href="https://admin.fedoraproject.org/accounts/user/new">
-                      FAS Sign-up page
-                    </a>{" "}
-                    and create it.
-                  </li>
-                  <li>Note the username and password, you will need it later on.</li>
-                </ul>
-              </CollapsableBadge>
-            </li>
-            <li>
-              Make sure your system is up-to-date: <code>sudo dnf update --refresh</code>
-            </li>
-            <li>
-              Install fedora-easy-karma tool: <code>sudo dnf install fedora-easy-karma</code>
-            </li>
-            <li>
-              Choose an update to test{" "}
-              <CollapsableBadge expand_text="Not sure how?">
-                Have a look at the available packages in <code>updates-testing</code> repo, by
-                running <code>dnf --enablerepo=updates-testing list --refresh --upgrades</code> and
-                choose a package you know.
-              </CollapsableBadge>
-            </li>
-            <li>
-              Install the package{" "}
-              <code>sudo dnf --enablerepo=updates-testing update PACKAGE_NAME</code>, and test
-              whether it works, as you would expect.
-              <br />
-              <strong>Note:</strong> Other packages from <code>updates-testing</code> repo may be
-              installed as dependencies (shown during the installation process). Try to test those
-              too, if possible.{" "}
-              <CollapsableBadge expand_text="Need some tips?">
-                Sometimes, the update associated with the package you just installed fixes some
-                specific bugs, or has testcases associated with it.
-                <br />
-                Run <code>fedora-easy-karma --fas-username=FAS_USERNAME</code>, and look for{" "}
-                <code>Bugs</code>, <code>Test Cases</code>, and/or <code>Notes</code> sections in
-                the detailed output.{" "}
-                <ModalBadge expand_text="Want something a bit nicer?">
-                  We already mentioned Bodhi, several times. Instead of using the{" "}
-                  <code>fedora-easy-karma</code> interface for submitting Karma and/or learning
-                  about the Update, you can visit Bodhi directly.
-                  <br />
-                  <code>fedora-easy-karma</code> shows the URL of the relevant update near the
-                  bottom of the text output - look for URL like{" "}
-                  <code>https://bodhi.fedoraproject.org/updates/FEDORA-2019-00870e8bfc</code>.
-                  <br />
-                  You can have a look at other people's comments, the afore-mentioned Bugs or Test
-                  Cases, and even submit the Karma directly. Just use your FAS credentials to
-                  log-in.
-                </ModalBadge>
-              </CollapsableBadge>
-            </li>
-            <li>
-              Run <code>fedora-easy-karma --fas-username=FAS_USERNAME</code> and report what you
-              found out.{" "}
-              <CollapsableBadge expand_text="New to fedora-easy-karma?">
-                It identifies the packages installed from the <code>updates-testing</code>{" "}
-                repository, and matches them to the updates in Bodhi.
-                <br />
-                You are then presented with the relevant updates one-by-one, to submit Karma and a
-                comment.{" "}
-                <ModalBadge expand_text="Not sure what Karma means?">
-                  <ol>
+          <CollapsableBadge expand_text="Karma">
+            ModalBadge Before a new version of a package is pushed to the Fedora&apos;s Updates
+            repository, it needs to be tested and proved functional.{" "}
+            <ModalBadge expand_text="Tell me more about the process!">
+              The updates are kept in{" "}
+              <a target="_blank" rel="noopener noreferrer" href="https://bodhi.fedoraproject.org/">
+                Bodhi
+              </a>
+              , which acts as a gatekeeper between new package releases and the stable
+              repositories. Users (or automated systems) can then provide feedback in form of
+              positive/negative Karma, marking the update as working (or not) within the scope of
+              their expectations. An update can (and usually does) consist of several packages
+              (rpms), that are going through the acceptance process together.
+            </ModalBadge>
+            <h1 style={{ marginTop: 1 + "em" }}>Sure, let me do it!</h1>
+            <ol className="steps">
+              <li>
+                Fedora Accounts System (FAS) account is required.{" "}
+                <ModalBadge expand_text="Don&#39;t have one yet?">
+                  <ul>
                     <li>
-                      Enter <code>1</code> to mark positive karma (the update works just fine, as
-                      far as you can tell), or <code>-1</code> to mark the package as broken.{" "}
-                      <br />
-                      Not sure you can judge the package's state? Have a look at the{" "}
+                      Visit{" "}
                       <a
                         target="_blank"
-                        href="https://fedoraproject.org/wiki/QA:Update_feedback_guidelines"
-                        rel="noopener noreferrer">
-                        Update Feedback Guidelines
-                      </a>
-                      <br />
-                      Still not sure? Just press <code>Enter</code> to skip it.
-                    </li>
-                    <li>
-                      Add a comment - even if it works, try to describe what you tested. It can be
-                      as easy as{" "}
-                      <code>I tried openning and editing a document, and it worked.</code> when you
-                      test a text-editor, or{" "}
-                      <code>I opened a couple of tabs, and browsed random pages.</code> for a
-                      web-browser.
-                      <br />
-                      Absolutely make sure to provide reasonable amount of detail, when submitting
-                      negative karma - ideally, you should also create a bugreport, and reference
-                      it in the comment.
+                        rel="noopener noreferrer"
+                        href="https://admin.fedoraproject.org/accounts/user/new">
+                        FAS Sign-up page
+                      </a>{" "}
+                      and create it.
                     </li>
-                  </ol>
+                    <li>Note the username and password, you will need it later on.</li>
+                  </ul>
                 </ModalBadge>
-              </CollapsableBadge>
-            </li>
-            <li>
-              Restore the stable-packages on your system by running{" "}
-              <code>sudo dnf distro-sync</code>
-            </li>
-          </ol>
+              </li>
+              <li>
+                Make sure your system is up-to-date: <code>sudo dnf update --refresh</code>
+              </li>
+              <li>
+                Install fedora-easy-karma tool: <code>sudo dnf install fedora-easy-karma</code>
+              </li>
+              <li>
+                Choose an update to test{" "}
+                <ModalBadge expand_text="Not sure how?">
+                  Have a look at the available packages in <code>updates-testing</code> repo, by
+                  running <code>dnf --enablerepo=updates-testing list --refresh --upgrades</code>{" "}
+                  and choose a package you know.
+                </ModalBadge>
+              </li>
+              <li>
+                Install the package{" "}
+                <code>sudo dnf --enablerepo=updates-testing update PACKAGE_NAME</code>, and test
+                whether it works, as you would expect.
+                <br />
+                <strong>Note:</strong> Other packages from <code>updates-testing</code> repo may be
+                installed as dependencies (shown during the installation process). Try to test
+                those too, if possible.{" "}
+                <ModalBadge expand_text="Need some tips?">
+                  Sometimes, the update associated with the package you just installed fixes some
+                  specific bugs, or has testcases associated with it.
+                  <br />
+                  Run <code>fedora-easy-karma --fas-username=FAS_USERNAME</code>, and look for{" "}
+                  <code>Bugs</code>, <code>Test Cases</code>, and/or <code>Notes</code> sections in
+                  the detailed output.{" "}
+                  <ModalBadge expand_text="Want something a bit nicer?">
+                    We already mentioned Bodhi, several times. Instead of using the{" "}
+                    <code>fedora-easy-karma</code> interface for submitting Karma and/or learning
+                    about the Update, you can visit Bodhi directly.
+                    <br />
+                    <code>fedora-easy-karma</code> shows the URL of the relevant update near the
+                    bottom of the text output - look for URL like{" "}
+                    <code>https://bodhi.fedoraproject.org/updates/FEDORA-2019-00870e8bfc</code>.
+                    <br />
+                    You can have a look at other people's comments, the afore-mentioned Bugs or
+                    Test Cases, and even submit the Karma directly. Just use your FAS credentials
+                    to log-in.
+                  </ModalBadge>
+                </ModalBadge>
+              </li>
+              <li>
+                Run <code>fedora-easy-karma --fas-username=FAS_USERNAME</code> and report what you
+                found out.{" "}
+                <ModalBadge expand_text="New to fedora-easy-karma?">
+                  It identifies the packages installed from the <code>updates-testing</code>{" "}
+                  repository, and matches them to the updates in Bodhi.
+                  <br />
+                  You are then presented with the relevant updates one-by-one, to submit Karma and
+                  a comment.{" "}
+                  <ModalBadge expand_text="Not sure what Karma means?">
+                    <ol>
+                      <li>
+                        Enter <code>1</code> to mark positive karma (the update works just fine, as
+                        far as you can tell), or <code>-1</code> to mark the package as broken.{" "}
+                        <br />
+                        Not sure you can judge the package's state? Have a look at the{" "}
+                        <a
+                          target="_blank"
+                          href="https://fedoraproject.org/wiki/QA:Update_feedback_guidelines"
+                          rel="noopener noreferrer">
+                          Update Feedback Guidelines
+                        </a>
+                        <br />
+                        Still not sure? Just press <code>Enter</code> to skip it.
+                      </li>
+                      <li>
+                        Add a comment - even if it works, try to describe what you tested. It can
+                        be as easy as{" "}
+                        <code>I tried openning and editing a document, and it worked.</code> when
+                        you test a text-editor, or{" "}
+                        <code>I opened a couple of tabs, and browsed random pages.</code> for a
+                        web-browser.
+                        <br />
+                        Absolutely make sure to provide reasonable amount of detail, when
+                        submitting negative karma - ideally, you should also create a bugreport,
+                        and reference it in the comment.
+                      </li>
+                    </ol>
+                  </ModalBadge>
+                </ModalBadge>
+              </li>
+              <li>
+                Restore the stable-packages on your system by running{" "}
+                <code>sudo dnf distro-sync</code>
+              </li>
+            </ol>
+          </CollapsableBadge>
         </div>
       )
   }
diff --git a/src/wizard/FedoraManualTesting.js b/src/wizard/FedoraManualTesting.js
index 9ef1f50..b1a7f0d 100644
--- a/src/wizard/FedoraManualTesting.js
+++ b/src/wizard/FedoraManualTesting.js
@@ -1,6 +1,6 @@
 import React, { Component } from "react"
 import { Modal, ModalHeader, ModalBody, ModalFooter } from "reactstrap"
-import { CollapsableCard, ModalBadge } from "./components"
+import { CollapsableCard, CollapsableBadge, ModalBadge } from "./components"
 
 export default class FedoraManualTesting extends Component {
   render() {
@@ -36,84 +36,87 @@ class FedoraManualTestingItemsListSub1 extends Component {
     subsections = <ul>{subsections}</ul>
 
     var l1 = <div></div>
-    switch (this.props.title) {
-      case "Installation":
-        l1 = (
-          <div>
-            The <strong>Installation</strong> testcases generally deal with a part of the
-            installation procedure.
-            <br />
-            You will certainly need an installation ISO, and either a Virtual or Bare-metal machine
-            to run the test.
-            <br />
-            <i>Note:</i> some (not that many, though) of these testcases require Bare-metal
-            machine. Be sure to read the Description of the testcase carefully.
-          </div>
-        )
-        break
-      case "Desktop":
-        l1 = (
-          <div>
-            The <strong>Desktop</strong> testcases cover basic functionality of the desktop
-            environment.
-            <br />
-            You can either install Fedora onto clean Virtual or Bare-metal machine, or use a Live
-            image instead.
-          </div>
-        )
-        break
-      case "Base":
-        l1 = (
-          <div>
-            The <strong>Base</strong> testcases cover the system&#x27;s basic functionality just
-            after a clean installation.
-            <br />
-            Most times, you will be asked to perform a clean Fedora installation. You can use
-            either Virtual or Bare-metal machine.
-            <br />
-            <i>Pro tip:</i> using a snapshot of cleanly installed Virtual machine is just fine. No
-            need to reinstall for every testcase.
-          </div>
-        )
-        break
-      case "Server":
-        l1 = (
-          <div>
-            The <strong>Server</strong> testcases usually require multiple machines to test the
-            server-client behaviour, and might feel a bit advanced.
-          </div>
-        )
-        break
-      case "Cloud":
-        l1 = (
-          <div>
-            Even thought the <strong>Cloud</strong> testcases are best done in the specific
-            environments like EC2 or Openstack, you can also perform them locally using Testcloud.
-            <br />
-            Have a look at the{" "}
-            <a
-              target="_blank"
-              rel="noopener noreferrer"
-              href="https://fedoraproject.org/wiki/Test_Results:Fedora_Current_Cloud#Cloud_Provider_Setup">
-              Cloud provider setup
-            </a>{" "}
-            guides for more details.
-          </div>
-        )
-        break
-      default:
-        break
+    switch (
+      this.props.title
+      // case "Installation":
+      //   l1 = (
+      //     <div>
+      //       The <strong>Installation</strong> testcases generally deal with a part of the
+      //       installation procedure.
+      //       <br />
+      //       You will certainly need an installation ISO, and either a Virtual or Bare-metal machine
+      //       to run the test.
+      //       <br />
+      //       <i>Note:</i> some (not that many, though) of these testcases require Bare-metal
+      //       machine. Be sure to read the Description of the testcase carefully.
+      //     </div>
+      //   )
+      //   break
+      // case "Desktop":
+      //   l1 = (
+      //     <div>
+      //       The <strong>Desktop</strong> testcases cover basic functionality of the desktop
+      //       environment.
+      //       <br />
+      //       You can either install Fedora onto clean Virtual or Bare-metal machine, or use a Live
+      //       image instead.
+      //     </div>
+      //   )
+      //   break
+      // case "Base":
+      //   l1 = (
+      //     <div>
+      //       The <strong>Base</strong> testcases cover the system&#x27;s basic functionality just
+      //       after a clean installation.
+      //       <br />
+      //       Most times, you will be asked to perform a clean Fedora installation. You can use
+      //       either Virtual or Bare-metal machine.
+      //       <br />
+      //       <i>Pro tip:</i> using a snapshot of cleanly installed Virtual machine is just fine. No
+      //       need to reinstall for every testcase.
+      //     </div>
+      //   )
+      //   break
+      // case "Server":
+      //   l1 = (
+      //     <div>
+      //       The <strong>Server</strong> testcases usually require multiple machines to test the
+      //       server-client behaviour, and might feel a bit advanced.
+      //     </div>
+      //   )
+      //   break
+      // case "Cloud":
+      //   l1 = (
+      //     <div>
+      //       Even thought the <strong>Cloud</strong> testcases are best done in the specific
+      //       environments like EC2 or Openstack, you can also perform them locally using Testcloud.
+      //       <br />
+      //       Have a look at the{" "}
+      //       <a
+      //         target="_blank"
+      //         rel="noopener noreferrer"
+      //         href="https://fedoraproject.org/wiki/Test_Results:Fedora_Current_Cloud#Cloud_Provider_Setup">
+      //         Cloud provider setup
+      //       </a>{" "}
+      //       guides for more details.
+      //     </div>
+      //   )
+      //   break
+      // default:
+      //   break
+    ) {
     }
 
     return (
-      <CollapsableCard title={l1} expand_text="See" expand_class="primary">
-        {subsections}
-      </CollapsableCard>
+      // <CollapsableCard title={l1} expand_text="Show me!" expand_class="primary">
+      //   {subsections}
+      // </CollapsableCard>
+      <> {subsections}</>
     )
   }
 }
 
-class FedoraManualTestingItem extends Component {
+export class FedoraManualTestingItem extends Component {
   render() {
     const extra_data = this.props.data.extra_data
 
@@ -230,7 +233,7 @@ class FedoraManualTestingItem extends Component {
                 </li>
                 <li>
                   Make sure to read about identifying the environment above.{" "}
-                  <ModalBadge expand_text="See">
+                  <ModalBadge expand_text="Show me!">
                     <ul>
                       <li>
                         Have a look at the matrix. The rows are the testcases, and the columns are
diff --git a/src/wizard/Filter.js b/src/wizard/Filter.js
index 3d822df..2568f68 100644
--- a/src/wizard/Filter.js
+++ b/src/wizard/Filter.js
@@ -1,4 +1,4 @@
-import React, { useState } from "react"
+import React, { useEffect, useState } from "react"
 import { shallowEqual, useSelector } from "react-redux"
 import {
   UncontrolledDropdown,
@@ -7,23 +7,41 @@ import {
   DropdownItem,
   Card,
   CardBody,
+  Col,
+  Row,
+  Button,
+  CardHeader,
 } from "reactstrap"
 
 import * as R from "ramda"
-import Easyfix from "./Easyfix"
+import { FedoraManualTestingItem } from "./FedoraManualTesting"
+import FedoraEasyKarma from "./FedoraEasyKarma"
 
-function Filter() {
-  const [lang, setLang] = useState(null)
-
-  const getlang = (lang) => {
-    setLang(lang)
-  }
+const intialFilter = {
+  language: null,
+  testtype: null,
+  duration: null,
+  area: null,
+}
 
+function Filter() {
   const selectAction = (state) => state.wizard.all_actions
-
   const actions = useSelector(selectAction, shallowEqual)
-  console.log(actions)
+
   const grouped = R.groupBy((action) => action.provider, actions["easyfix"])
+  const grouped2 = R.groupBy((action) => action.provider, actions["fedora_manual_testing"])
+  const grouped3 = R.groupBy((action) => action.provider, actions["fedora_easy_karma"])
+
+  const [filteredData, setfilteredData] = useState(actions)
+
+  const [filters, setFilters] = useState(intialFilter)
+
+  const setFilter = (filterType, value) => {
+    setFilters({
+      ...filters,
+      [filterType]: value,
+    })
+  }
 
   const getData = () => {
     const getUniqueTags = R.pipe(
@@ -35,36 +53,210 @@ function Filter() {
     return tags
   }
 
-  //   const processData = (data, firstLevelGroupKey, secondLevelGroupKey) => {
-  //     const getProcessedData = R.pipe(
-  //       R.groupBy((a) => a.extra_data[firstLevelGroupKey]),
-  //       R.map((v) => R.groupBy((a) => a.extra_data[secondLevelGroupKey], v))
-  //     )
-  //     return getProcessedData(data)
-  //   }
+  const getDataTestcase = () => {
+    const getUniqueTags = R.pipe(
+      R.map((action) => action.extra_data.testtype),
+      R.flatten,
+      R.uniq
+    )
+    const testtype = getUniqueTags(grouped2["fedora_manual_testing"])
+    return testtype
+  }
+
+  const resetData = () => {
+    setfilteredData({ ...actions })
+    setFilters(intialFilter)
+  }
 
-  //   const getData2 = () => {
-  //     const actions = R.filter((a) => a.tags.includes(lang), grouped["easyfix"])
-  //     return actions
-  //   }
+  const filterData = () => {
+    let data = { ...actions }
+    const { language, testtype, area, duration } = filters
 
-  //   const easyfixTestingData = processData(grouped["easyfix"] || [], "repo_org", "repo_name")
+    if (language) {
+      data = {
+        easyfix: data.easyfix?.filter((issue) => issue.tags.includes(language)),
+        fedora_manual_testing: null,
+        fedora_easy_karma: null,
+      }
+    }
+    if (testtype) {
+      data = {
+        fedora_manual_testing: data.fedora_manual_testing?.filter((test) =>
+          test.extra_data.testtype.includes(testtype)
+        ),
+        easyfix: null,
+        fedora_easy_karma: null,
+      }
+    }
+    if (area) {
+      switch (area) {
+        case "PROGRAMMING":
+          data = {
+            easyfix: data.easyfix,
+            fedora_manual_testing: null,
+            fedora_easy_karma: null,
+          }
+          break
+        case "TESTING":
+          data = {
+            fedora_manual_testing: data.fedora_manual_testing,
+            fedora_easy_karma: data.fedora_easy_karma,
+            easy_fix: null,
+          }
+          break
+        default:
+      }
+    }
+    if (duration) {
+      switch (duration) {
+        case "FEW_HOURS":
+          data = {
+            fedora_manual_testing: data.fedora_manual_testing,
+            fedora_easy_karma: data.fedora_easy_karma,
+            easyfix: null,
+          }
+          break
+        case "SEVERAL_DAYS":
+          data = {
+            easyfix: data.easyfix,
+            fedora_manual_testing: null,
+            fedora_easy_karma: null,
+          }
+          break
+        default:
+      }
+    }
+    setfilteredData(data)
+  }
 
-  console.log(lang)
+  useEffect(() => {
+    filterData()
+  }, [filters])
 
   return (
     <div>
-      <UncontrolledDropdown>
-        <DropdownToggle caret>language</DropdownToggle>
-        <DropdownMenu>
-          {getData().map((language) => (
-            <DropdownItem onClick={() => getlang(language)}>{language}</DropdownItem>
-          ))}
-        </DropdownMenu>
-      </UncontrolledDropdown>
-      {/* <Easyfix data={easyfixTestingData} key="easyfix" /> */}
+      <Row>
+        <Col sm="2">
+          <UncontrolledDropdown className="actions">
+            <DropdownToggle caret>
+              {filters.duration ? filters.duration : "Duration"}
+            </DropdownToggle>
+            <DropdownMenu>
+              <DropdownItem onClick={() => setFilter("duration", "SEVERAL_DAYS")}>
+                Several Days
+              </DropdownItem>
+              <DropdownItem onClick={() => setFilter("duration", "FEW_HOURS")}>
+                Few Hours
+              </DropdownItem>
+            </DropdownMenu>
+          </UncontrolledDropdown>
+        </Col>
+
+        <Col sm="2">
+          <UncontrolledDropdown className="actions">
+            <DropdownToggle caret>{filters.area ? filters.area : "Area"}</DropdownToggle>
+            <DropdownMenu>
+              <DropdownItem onClick={() => setFilter("area", "TESTING")}>Testing</DropdownItem>
+              <DropdownItem onClick={() => setFilter("area", "PROGRAMMING")}>
+                Programming
+              </DropdownItem>
+            </DropdownMenu>
+          </UncontrolledDropdown>
+        </Col>
+
+        <Col sm="2">
+          <UncontrolledDropdown className="actions">
+            <DropdownToggle caret>
+              {filters.language ? filters.language : "language"}
+            </DropdownToggle>
+            <DropdownMenu>
+              {getData().map((language) => (
+                <DropdownItem onClick={() => setFilter("language", language)}>
+                  {language}
+                </DropdownItem>
+              ))}
+            </DropdownMenu>
+          </UncontrolledDropdown>
+        </Col>
+        <Col sm="2">
+          <UncontrolledDropdown className="actions">
+            <DropdownToggle caret>
+              {filters.testtype ? filters.testtype : "testtype"}
+            </DropdownToggle>
+            <DropdownMenu>
+              {getDataTestcase().map((testtype) => (
+                <DropdownItem onClick={() => setFilter("testtype", testtype)}>
+                  {testtype}
+                </DropdownItem>
+              ))}
+            </DropdownMenu>
+          </UncontrolledDropdown>
+        </Col>
+        <Col sm="2">
+          <Button onClick={resetData} className="actions" color="primary">
+            Click to reset! <i class="fas fa-wrench"></i>
+          </Button>
+        </Col>
+      </Row>
+      <Row>
+        {Object.keys(filteredData).map((key, index) => (
+          <React.Fragment key={key}>
+            {key === "easyfix" &&
+              filteredData[key] &&
+              filteredData[key].map((data) => (
+                <Col sm="4" md="3" className="card-container">
+                  <Card key={data.extra_data.ticket_url} className="actions">
+                    <CardHeader>
+                      <i class="fas fa-terminal"></i>
+                      &nbsp; {data.extra_data.repo_fullname}
+                    </CardHeader>
+                    <CardBody>
+                      <a
+                        href={data.extra_data.ticket_url}
+                        target="_blank"
+                        rel="noopener noreferrer">
+                        {data.name}
+                      </a>
+                    </CardBody>
+                  </Card>
+                </Col>
+              ))}
+
+            {key === "fedora_manual_testing" &&
+              filteredData[key] &&
+              filteredData[key].map((data) => (
+                <Col sm="4" md="3" className="card-container">
+                  <Card className="actions">
+                    <CardHeader>
+                      <i class="fas fa-flask"></i>
+                      &nbsp; {data.extra_data.milestone}
+                    </CardHeader>
+                    <CardBody>
+                      <FedoraManualTestingItem data={data} />
+                    </CardBody>
+                  </Card>
+                </Col>
+              ))}
+
+            {key === "fedora_easy_karma" &&
+              filteredData[key] &&
+              filteredData[key].map((data) => (
+                <Col sm="4" md="3" className="card-container">
+                  <Card className="actions">
+                    <CardHeader>
+                      <i class="fab fa-fedora"></i>
+                      &nbsp; {data.name}
+                    </CardHeader>
+                    <CardBody>
+                      <FedoraEasyKarma data={grouped3["fedora_easy_karma"]} key="karma" />
+                    </CardBody>
+                  </Card>
+                </Col>
+              ))}
+          </React.Fragment>
+        ))}
+      </Row>
     </div>
   )
 }
-
 export default Filter
